#include "global.h"
#include "exec.h"
#include "interpret.h"
#include "object.h"
#include "array.h"

int hashmem(register const char *p,int len,int maxn,int hashs)
{
  register unsigned int h;
  register const char *i;

  h=len*9248339;
  if(maxn<len)
    i=p+maxn;
  else
    i=p+len;

  if(p<i)
  {
    h+=*(p++);
    if(p<i)
    {
      h+=*(p++)+(h<<9);
      if(p<i)
      {
	h+=*(p++)+(h<<6);
	while(p+5<i)
	{
	  h+=*(p++)^(h<<5);
	  h+=*(p++)^(h<<11);
	  h+=*(p++)^(h<<8);
	  h+=*(p++)^(h<<3);
	  h+=*(p++)^(h<<4);
	}
	while(p<i) h+=*(p++)^(h<<7);
      }
    }
  }
  return (int)(h % hashs);
}


int hashstr(const char *str,int maxn,int hashs)
{
  int n;
  n=strlen(str);
  return hashmem(str,n,maxn,hashs);
}


int hash_svalue(struct svalue *s,int size)
{
  switch (s->type)
  {
    case T_NUMBER: return (s->u.number) % size;
    case T_OBJECT: return (s->u.ob->clone_number) % size;
    case T_STRING: return hashstr(s->u.string,100,size);
    case T_POINTER:
    case T_ALIST_PART: return s->u.vec->size % size;
    case T_LIST:
    case T_MAPPING:  return s->u.vec->item[0].u.vec->size % size;
    default: return 0;
  }
}
